'部材２Ｄ振動応答解析V77の標準ﾓｼﾞｭｰﾙ        ［作成］黒田英夫(2023/03)
Imports System.Drawing.Printing

Module BarsVRCom
    'トラスおよびラーメンの振動応答解析
    'トラス・・・節点が自由回転
    'ラーメン・・・節点が固定接続
    '「部材２次元体解析」Bars2Dの構造データを利用
    'ＭＫ型およびＭＣＫ型で振動外力への応答変化を計算
    'ＭＫ型：Ｋｘ＝λＭｘ
    'ＭＣＫ型：μ^2Ｍｚ＋μＣｚ＋Ｋｚ＝０

    'V66での改良点・・・各画面でボタンを読みやすい色に改善
    'V67での改良点・・・応力図の変数項目の増加、最大・最小値の表示内容の変更、
    '                   σfminの応力図のバグを修正
    'V68での改良点・・・Visual Basic 2017に変更
    'V69での改良点・・・プログラムファイルの文字コードをUTF-8に統一、
    '                   データファイルの文字コードを標準でUTF-8に変更
    '                   （従来のShift-JISもオプションで可能）
    'V70での改良点・・・アニメーションの動作エラーを修正
    'V71での改良点・・・ファイル入出力画面でキャンセル処理の改善
    'V72での改良点・・・データ表画面で表計算ソフトから貼り付け時に次行に0が入るのを防止
    'V73での改良点・・・入力データのファイル印刷メニューを廃止
    '                   （文字コードによる不具合のため）
    'V74での改良点・・・計算時の節点付番の改良で各座標軸方向のバンド幅を算出
    '                   （これまでは最長方向の座標軸を採用）
    'V75での改良点・・・構造図画面で条件設定部の表示を２区分から３区分に改善、
    '                   構造図画面で条件設定部の線分幅を拡大
    'V76での改良点・・・部材２次元体解析の入力データファイルで拘束節点の形式変更に対応
    'V77での改良点・・・フリーソフト化、VB2022に移行、文字コードはUTF-8のみ採用

    Public Const Dpai As Single = 6.283185 '2π
    Public Const Pai As Single = 3.141593  'π

    Public CalcRes$                 '計算結果表示データ
    Public Cr$                      'CR+LFのコード
    Public DirOpen$                 '立ち上げ時のディレクトリー名
    Public Fbars$                   'Bars2D構造ファイル名
    Public Fgraph$                  'ｸﾞﾗﾌﾃﾞｰﾀの出力ﾌｧｲﾙ名
    Public Fm$                      '入力データのファイル名
    Public Fy$                      '計算結果のファイル名
    Public Fy2$                     '一時保存ﾌｧｲﾙ
    Public Title$                   'タイトル

    Public Timst As Date            '計算開始時刻

    Public InitCond As Integer      'ﾊﾞｯﾁ処理で計算条件設定の有無（0:なし、1:有り）
    Public InOut As Integer         'ファイル入出力の種類（0:入力、1:出力）
    Public KAnal As Integer         '解析種類（0:一般応答、1:周波数応答）
    Public Kaxis As Integer         '作図のＸＹ軸の入換え（0:なし、1:有り）
    Public Kboundfree As Integer    '境界拘束解除の有無（0:なし、1:有り）
    Public KdataBackup As Integer   '入力データのバックアップファイル作成（0:なし、1:有り）
    Public KdataChange As Integer   'データ変更の有無（0:なし、1:有り）
    Public KE1 As Integer           '開始要素番号
    Public KE2 As Integer           '最終要素番号
    Public KfileOK As Integer       'ﾌｧｲﾙのOK有無（0:なし、1:有り）
    Public Kfinish As Integer       'ﾊﾞｯﾁ処理１回の終了区分（0:未終了、1:終了）
    Public KindBatch As Integer     'ﾊﾞｯﾁ処理の有無（0:なし、1:有り）
    Public KindDamp As Integer      '減衰設定区分（0:比例減衰、1:個別設定）
    '    Public KindEncod As Integer     'ファイルの文字コード（0:UTF-8、1:Shif-JIS）
    Public KindGraph As Integer     'ｸﾞﾗﾌ種類（1:１節点多変数、2:多節点１変数）
    Public KindLvib As Integer      '振動外力の種類（0:力、1:加速度）
    Public KindPost As Integer      '後処理の種類（1:変位図、2:応力図、
    '                                3:ｸﾞﾗﾌﾃﾞｰﾀの作成、4:ｱﾆﾒｰｼｮﾝ、
    '                                5:周波数分析、6:端数処理、7:解析結果の主要値表示）
    Public KindSLoad As Integer     '静荷重の有無（0:なし、1:有り）
    Public KindVEqua As Integer     '方程式種類（0:ＭＫ型、1:ＭＣＫ型）
    Public KmouseDchange As Integer 'ﾏｳｽ指定要素のﾃﾞｰﾀ変更有無
    Public KmouseElem As Integer    'ﾏｳｽ指定の要素番号
    Public KmousePoint As Integer   'ﾏｳｽ指定の節点番号
    Public KnewUFileA As Integer    '最近使用ﾌｧｲﾙAの更新有無
    Public KnewUFileB As Integer    '最近使用ﾌｧｲﾙBの更新有無
    Public KnumSb As Integer        'ﾌｫﾝﾄ文字ｻｲｽﾞの操作変数
    Public KnumSize As Integer      '構造作画での番号ｻｲｽﾞ
    Public Kscreen As Integer       '作画画面サイズ（0：全画面、1：通常画面）
    Public Kstep As Integer         '指定の時間ﾒｯｼｭ番号
    Public Kvalue As Integer        '作画の変数ｲﾝﾃﾞｯｸｽ
    Public KvalueG As Integer       'ｸﾞﾗﾌﾃﾞｰﾀの変数ｲﾝﾃﾞｯｸｽ
    Public Mprop As Integer         '材料データの成分数(3～4)
    Public Nall As Integer          '変数の総数
    Public Nbound As Integer        '拘束節点数
    Public Ndamp As Integer         'ダンパーの数
    Public Ndim As Integer          '１節点当りの変数の数(2～3)
    Public NdivCyc As Integer       '１周期分割数
    Public Nelem As Integer         '要素数
    Public Nforce As Integer        '荷重節点数
    Public NKmax As Integer         '最大繰返し数
    Public NLvib As Integer         '振動外力の荷重個数
    Public Nmat As Integer          '材料データ数
    Public Norder As Integer        '正方行列の次数
    Public NPgraph As Integer       'ｸﾞﾗﾌ節点指定（節点番号または節点数）
    Public Npoint As Integer        '節点数
    Public NPvib As Integer         '振動外力節点数
    Public Nspring As Integer       'バネ支持個数
    Public Nstep As Integer         '出力時間間隔の倍数（1以上の整数）
    Public NstepF As Integer        '振動外力時間間隔の倍数（1以上の整数）
    Public Nsurf As Integer         '表面分布荷重数
    Public Ntype As Integer         '問題のタイプ（1:トラス、2:ラーメン、3:両者混合）
    Public Nvar As Integer          '１要素当りの変数の総数
    Public NvibTime As Integer      '振動外力の時間メッシュ数

    Public AngleN As Single         '周期内角度（°）
    Public Cfix As Single           'XY方向ﾋﾟｸｾﾙ差の補正係数
    Public CoeffK As Single         '質量比例の減衰係数
    Public CoeffM As Single         '剛性比例の減衰係数
    Public DispRatio As Single      '変位作画の倍率
    Public DTime As Single          '振動応答計算の時間間隔
    Public EpsCalc As Single        '収束判定誤差比率
    Public FreqLVib As Single       '振動外力の周波数
    Public TimeMax As Single        '打切り時間
    Public TimeNew As Single        '現在の計算時刻
    Public XaxisMax As Single       'Ｘ軸の最大値
    Public XaxisMin As Single       'Ｘ軸の最小値
    Public Xlower As Single         '作画領域のX最小値
    Public Xupper As Single         '作画領域のX最大値
    Public XYscale As Single        '作画スケール
    Public YaxisMax As Single       'Ｙ軸の最大値
    Public YaxisMin As Single       'Ｙ軸の最小値
    Public Ylower As Single         '作画領域のY最小値
    Public Yupper As Single         '作画領域のY最大値

    Public UFileA(6) As String      '最近使用した構造ﾌｧｲﾙの保存配列
    Public UFileB(6) As String      '最近使用した解析ﾌｧｲﾙの保存配列

    Public Jdirect(,) As Integer    '節点拘束の各軸方向拘束有無(0:非拘束、1:拘束）
    Public JLoadVib(,) As Integer   '節点振動外力の各軸方向の有無
    Public Kdispmb() As Integer     '全体行列の変数番号対応の変位方向
    Public KdispMatR() As Integer   '入力ﾃﾞｰﾀの変数番号対応の変位方向
    Public KdrawElem() As Integer   '各要素の作画有無（0:なし、1:有り）
    Public KEsurf() As Integer      '表面分布荷重の要素番号
    Public KindElem() As Integer    '要素種類（1:トラス、2:ラーメン、3:左節点回転自由、
    '                                4:右節点回転自由）
    Public KPdamp(,) As Integer     'ダンパーの2節点番号
    Public KPforce() As Integer     '節点荷重の節点番号
    Public KPgraph(20) As Integer   'ｸﾞﾗﾌ節点番号
    Public KPspring(,) As Integer   'バネ支持の節点番号
    Public KPsurf(,) As Integer     '表面分布荷重の２節点番号（旧ﾃﾞｰﾀ）
    Public KPvib() As Integer       '振動外力の節点番号
    Public LrD() As Integer         '元ﾃﾞｰﾀ節点の第1変数の元全体ﾏﾄﾘｯｸｽ番号
    Public NNelem(,) As Integer     '各要素における全節点番号
    Public Nodemb() As Integer      '元全体行列の変数番号対応の節点番号
    Public NodeMatR() As Integer    '入力ﾃﾞｰﾀの変数番号対応の節点番号
    Public NPrefer() As Integer     '要素計算における節点変数の対応番号
    Public Nrest() As Integer       '拘束の節点番号
    Public NumMat() As Integer      '各要素の材料種類番号
    Public NvarPD() As Integer      '元ﾃﾞｰﾀ節点の変数の数

    Public Cmatrix() As Single      'Ｃ行列
    Public Cspring(,) As Single     'バネ定数
    Public DataDamp(,) As Single    'ダンパーの外部点座標と減衰係数
    Public DataFreq(,) As Single    '周波数外力の各ﾃﾞｰﾀ（振幅と位相差）
    Public DataMat(,) As Single     '各材料の物性値
    Public FLvibTime(,) As Single   '各時間毎の振動外力
    Public Force(,) As Single       '節点荷重値（各軸方向）
    Public Fspring(,) As Single     '初期バネ力（各軸方向）
    Public Pnorm() As Single        '表面の垂直方向分布荷重（単位面積当り）
    Public Ptang() As Single        '表面の接線方向分布荷重（単位面積当り）
    Public RMmatrix() As Single     'Ｍ行列（対角要素のみ）
    Public RouMat() As Single       '各材料の密度
    Public Tdisp(,) As Single       '結果の変位
    Public Tf() As Single           'FEM計算の右辺ベクトル
    Public Vdirect(,) As Single     '節点拘束の各軸方向拘束値
    Public X(), Y() As Single       '節点座標
    Public XE(2), YE(2) As Single   '要素計算の配列
    Public Xmouse(), Ymouse() As Single     'ﾏｳｽ位置座標
    Public Xnew(), Ynew() As Single   '変位入りの節点座標


    Sub AccDataCheck(ByRef kh As Integer)
        '加速度加振ﾃﾞｰﾀのﾁｪｯｸ
        'kh･･･ｴﾗｰ有無（0:なし、2:周波数加振が全要素有り）
        Dim i, ic, ie, j, k As Integer

        kh = 0
        If KAnal = 1 Then
            kh = 2
            For ie = 1 To Nelem
                ic = 0
                For j = 1 To 2
                    k = NNelem(ie, j)
                    For i = 1 To NPvib
                        If k = KPvib(i) Then
                            ic = 1
                            Exit For
                        End If
                    Next i
                Next j
                If ic = 0 Then
                    kh = 0
                    Exit Sub
                End If
            Next ie
        End If

    End Sub

    Sub AdjustRatio(ByRef ratio As Single)
        '変位比率の調整
        Dim nb As Integer
        Dim b1, b2, std As Single

        std = 0.05
        b1 = std / ratio
        If b1 < 1.0 Then
            ratio = 1.0
        ElseIf b1 < 10.0 Then
            b2 = b1 * 10
            ratio = Int(b2) / 10.0
        Else    '上位2桁を採用
            b2 = b1
            nb = 0
            Do
                b2 = b2 / 10
                nb = nb + 1
                If b2 < 10 Then
                    Exit Do
                End If
            Loop
            b2 = Int(b2 * 10)
            If nb < 2 Then
                ratio = b2
            Else
                ratio = b2 * 10 ^ (nb - 1)
            End If
        End If

    End Sub

    Sub AxisCheck(ByRef icheck As Integer, ByVal k1 As Integer, _
    ByVal k2 As Integer, ByVal ratio As Single, ByRef xmin As Single, _
    ByRef xmax As Single, ByRef ymin As Single, ByRef ymax As Single, _
    ByRef xd() As Single, ByRef yd() As Single)
        'X、Y軸の最小・最大値と作画直角回転要否のﾁｪｯｸ
        'icheck･･･作画直角回転要否（0:回転なし、1:直角回転要）
        'k1,k2･･･要素の開始、終了番号
        'ratio･･･作画直角回転なしの縦横比上限（指定値）
        'xmin･･･X座標最小値
        'xmax･･･X座標最大値
        'ymin･･･Y座標最小値
        'ymax･･･Y座標最大値
        'xd(),yd()･･･節点の座標
        Dim i, ie, ik, j As Integer
        Dim b1, b2, ratiob As Single
        ik = 0
        For ie = k1 To k2
            If KdrawElem(ie) > 0 Then
                For j = 1 To 2
                    i = NNelem(ie, j)
                    If ik = 0 Then
                        ik = 1
                        xmin = xd(i) : xmax = xmin
                        ymin = yd(i) : ymax = ymin
                    Else
                        If xd(i) < xmin Then
                            xmin = xd(i)
                        ElseIf xd(i) > xmax Then
                            xmax = xd(i)
                        End If
                        If yd(i) < ymin Then
                            ymin = yd(i)
                        ElseIf yd(i) > ymax Then
                            ymax = yd(i)
                        End If
                    End If
                Next j
            End If
        Next ie
        b1 = xmax - xmin
        b2 = ymax - ymin
        If b1 <> 0 Then
            ratiob = b2 / b1
            If ratiob > ratio Then
                icheck = 1
            Else
                icheck = 0
            End If
        Else
            icheck = 1
        End If

    End Sub

    Sub AxisCheckS(ByVal k1 As Integer, ByRef k2 As Integer, ByRef xmin As Single, _
    ByRef xmax As Single, ByRef ymin As Single, ByRef ymax As Single, _
    ByRef xdb() As Single, ByRef ydb() As Single)
        'X･Y座標の最小・最大値のﾁｪｯｸ
        'k1,k2･･･要素の開始、終了番号
        'xmin･･･X座標最小値
        'xmax･･･X座標最大値
        'ymin･･･Y座標最小値
        'ymax･･･Y座標最大値
        'xdb(),ydb()･･･節点座標
        Dim i, ie, ik, j As Integer
        ik = 0
        For ie = k1 To k2
            If KdrawElem(ie) > 0 Then
                For j = 1 To 2
                    i = NNelem(ie, j)
                    If ik = 0 Then
                        ik = 1
                        xmin = xdb(i) : xmax = xmin
                        ymin = ydb(i) : ymax = ymin
                    Else
                        If xdb(i) < xmin Then
                            xmin = xdb(i)
                        ElseIf xdb(i) > xmax Then
                            xmax = xdb(i)
                        End If
                        If ydb(i) < ymin Then
                            ymin = ydb(i)
                        ElseIf ydb(i) > ymax Then
                            ymax = ydb(i)
                        End If
                    End If
                Next j
            End If
        Next ie

    End Sub

    Sub AxisSet(ByRef tdb(,) As Single)
        '座標の設定
        Dim i As Integer
        For i = 1 To Npoint
            Xnew(i) = X(i) + DispRatio * tdb(i, 1)
            Ynew(i) = Y(i) + DispRatio * tdb(i, 2)
        Next i
    End Sub

    Sub AxisValueTreat(ByRef xbuf() As Single, ByRef ybuf() As Single)
        '座標値の端数処理
        'xbuf(),ybuf()･･･節点の座標
        Dim i, ie, kind, nb As Integer
        Dim b1, b2, pa, qa, ratio As Single
        ReDim KdrawElem(Nelem)

        For ie = 1 To Nelem
            KdrawElem(ie) = 1
        Next ie

        ratio = 1.2
        Kaxis = 0
        Call AxisCheck(Kaxis, 1, Nelem, ratio, XaxisMin, pa, YaxisMin, qa, X, Y)
        'X、Y軸の最小・最大値と作画直角回転要否のﾁｪｯｸ

        b1 = pa - XaxisMin
        b2 = qa - YaxisMin
        If b2 > b1 Then
            b1 = b2
        End If
        b2 = b1 * 0.00002
        Call RoundPrep(kind, nb, b2)    '丸め準備

        For i = 1 To Npoint
            xbuf(i) = X(i)
            ybuf(i) = Y(i)
        Next i
        For i = 1 To Npoint
            If xbuf(i) <> 0 Then
                Call RoundTreat(kind, nb, xbuf(i)) '丸め処理
            End If
            If ybuf(i) <> 0 Then
                Call RoundTreat(kind, nb, ybuf(i)) '丸め処理
            End If
        Next i

    End Sub

    Sub CfileInputU(ByVal fxx$, ByRef kh As Integer, ByVal kstepx As Integer)
        '計算結果ﾌｧｲﾙの読込み
        'UTF-8･･･BOMなし
        'fxx$･･･計算結果ﾌｧｲﾙ名
        'kh･･･ﾃﾞｰﾀ有無（0:なし、1:有り）
        'kstepx･･･指定ｽﾃｯﾌﾟ番号（-1の場合は計算条件部分）
        Dim aa$
        Dim istep As Integer

        aa$ = ""
        kh = 0
        Dim sr As New IO.StreamReader(fxx$)
        Dim dat() As String
        If kstepx < 0 Then
            Do
                aa$ = sr.ReadLine
                If aa$ = "＜パラメーター条件＞" Then
                    kh = 1
                    Exit Do
                End If
            Loop
            If KAnal = 0 Then
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                TimeMax = dat(1)
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                DTime = dat(1)
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                NstepF = dat(1)
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                Nstep = dat(1)
            Else
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                NKmax = dat(1)
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                NdivCyc = dat(1)
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                EpsCalc = dat(1)
            End If
        Else
            If KAnal = 0 Then
                Do
                    aa$ = sr.ReadLine
                    dat = aa.Split(",")
                    If dat(0) = "＜時間メッシュ番号、時間＞" Then
                        istep = dat(1)
                        TimeNew = dat(2)
                        If istep = kstepx Then
                            kh = 1
                            Exit Do
                        End If
                    End If
                Loop
            Else
                Do
                    aa$ = sr.ReadLine
                    dat = aa.Split(",")
                    If dat(0) = "＜周期内メッシュ番号、角度、周期内時間＞" Then
                        istep = dat(1)
                        AngleN = dat(2)
                        TimeNew = dat(3)
                        If istep = kstepx Then
                            kh = 1
                            Exit Do
                        End If
                    End If
                Loop
            End If
        End If

        sr.Close()

    End Sub

    Sub DampErrorCheck(ByRef kh As Integer)  'ﾀﾞﾝﾊﾟｰのｴﾗｰﾁｪｯｸ
        'kh･･･ｴﾗｰ有無（0：なし、1：節点番号ｴﾗｰ、2：減衰係数ｴﾗｰ）
        Dim i, j, kb As Integer

        kh = 0
        For i = 1 To Ndamp
            For j = 1 To 2
                kb = KPdamp(i, j)
                If j = 1 Or kb > 0 Then
                    If kb <= 0 Or kb > Npoint Then
                        kh = 1
                        Exit Sub
                    End If
                End If
            Next j
            If DataDamp(i, 3) <= 0 Then
                kh = 2
                Exit Sub
            End If
        Next i

    End Sub

    Sub DataStoreCheck(ByRef ix As Integer)
        'ﾃﾞｰﾀ保存の確認
        'ix･･･返答（6:yes、それ以外は中止）
        ix = 0
        If KdataChange > 0 Then
            Dim aa$
            aa$ = Fm$ + "ファイルが変更されていますが、保存なしでよいですか？"
            ix = MsgBox(aa$, 4, "データ変更の警告")
            If ix = 6 Then
                KdataChange = 0
            End If
        End If

    End Sub

    Sub Dfile2InputU(ByVal fxx$)
        '構造ﾃﾞｰﾀﾌｧｲﾙの読み込み
        'UTF-8･･･BOMなし
        'fxx$･･･構造ﾃﾞｰﾀﾌｧｲﾙ名
        Dim aa$
        Dim i, id, j, jb, jm As Integer

        Dim sr As New IO.StreamReader(fxx$)
        Dim dat() As String

        aa$ = sr.ReadLine
        dat = aa.Split(",")
        If dat(0) <> "プログラム名" Then
            aa$ = "本ソフトのUTF-8データファイルとは違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        If dat(1) <> "Bars2D" Then
            aa$ = "データファイルが違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        Title$ = sr.ReadLine
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Ntype = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Npoint = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nelem = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nbound = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nmat = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nforce = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nsurf = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nspring = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Ndim = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Mprop = dat(1)

        ReDim KindElem(Nelem), NNelem(Nelem, 2), NumMat(Nelem), X(Npoint), Y(Npoint)
        ReDim Nrest(Nbound), Jdirect(Nbound, 3), Vdirect(Nbound, 3)
        ReDim DataMat(Nmat, 7)
        ReDim KPforce(Nforce), Force(Nforce, 3)
        ReDim KEsurf(Nsurf), Pnorm(Nsurf), Ptang(Nsurf)
        ReDim KPspring(Nspring, 2), Cspring(Nspring, 2), Fspring(Nspring, 2)

        aa$ = sr.ReadLine
        If Ntype < 3 Then
            For i = 1 To Nelem
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                NumMat(i) = dat(1)
                For j = 1 To 2
                    NNelem(i, j) = dat(j + 1)
                Next j
            Next i
        Else
            For i = 1 To Nelem
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                KindElem(i) = dat(1)
                NumMat(i) = dat(2)
                For j = 1 To 2
                    NNelem(i, j) = dat(j + 2)
                Next j
            Next i
        End If

        aa$ = sr.ReadLine
        For i = 1 To Npoint
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            X(i) = dat(1)
            Y(i) = dat(2)
        Next i

        aa$ = sr.ReadLine
        If Len(aa$) < 10 Then
            For i = 1 To Nbound
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                Nrest(i) = dat(3)
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                For j = 1 To Ndim
                    jb = 4 * (j - 1)
                    Jdirect(i, j) = dat(jb + 1)
                    Vdirect(i, j) = dat(jb + 3)
                Next j
            Next i
        Else
            For i = 1 To Nbound
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                Nrest(i) = dat(1)
                For j = 1 To Ndim
                    jb = 2 * j
                    Jdirect(i, j) = dat(jb)
                    Vdirect(i, j) = dat(jb + 1)
                Next j
            Next i
        End If

        aa$ = sr.ReadLine
        jm = Mprop
        For i = 1 To Nmat
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            For j = 1 To jm
                DataMat(i, j) = dat(j)
            Next j
        Next i

        If Nforce > 0 Then
            aa$ = sr.ReadLine
            For i = 1 To Nforce
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                KPforce(i) = dat(1)
                For id = 1 To Ndim
                    Force(i, id) = dat(id + 1)
                Next id
            Next i
        End If

        If Nsurf > 0 Then
            aa$ = sr.ReadLine
            For i = 1 To Nsurf
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                KEsurf(i) = dat(1)
                Pnorm(i) = dat(2)
                Ptang(i) = dat(3)
            Next i
        End If

        If Nspring > 0 Then
            aa$ = sr.ReadLine
            For i = 1 To Nspring
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                For j = 1 To 2
                    KPspring(i, j) = dat(j)
                Next j
                For j = 1 To 2
                    jb = 2 * j
                    Cspring(i, j) = dat(jb + 1)
                    Fspring(i, j) = dat(jb + 2)
                Next j
            Next i
        End If

        sr.Close()

    End Sub

    Sub DfileInputU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙの読み込み
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾌｧｲﾙ名
        Dim aa$
        Dim i, id, j As Integer

        Dim sr As New IO.StreamReader(fxx$)
        Dim dat() As String

        aa$ = sr.ReadLine
        dat = aa.Split(",")
        If dat(0) <> "プログラム名" Then
            aa$ = "本ソフトのUTF-8データファイルとは違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        If dat(1) <> "BarsVibRes" Then
            aa$ = "データファイルが違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Fbars$ = dat(1)
        Title$ = sr.ReadLine
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Ntype = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Npoint = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        KindVEqua = dat(1)
        If KindVEqua = 0 Then
            KindDamp = 0
            Ndamp = 0
        Else
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            KindDamp = dat(1)
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            Ndamp = dat(1)
        End If
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        KAnal = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Kboundfree = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Norder = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nmat = dat(1)

        ReDim RouMat(Nmat)
        ReDim NodeMatR(Norder), KdispMatR(Norder)

        If Ndamp > 0 Then
            ReDim KPdamp(Ndamp, 2)
            ReDim DataDamp(Ndamp, 3)
            aa$ = sr.ReadLine
            For i = 1 To Ndamp
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                KPdamp(i, 1) = dat(1)
                KPdamp(i, 2) = dat(2)
                For j = 1 To 3
                    DataDamp(i, j) = dat(j + 2)
                Next j
            Next i
        End If

        aa$ = sr.ReadLine
        For i = 1 To Nmat
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            RouMat(i) = dat(1)
        Next i

        aa$ = sr.ReadLine
        For i = 1 To Norder
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            NodeMatR(i) = dat(1)
            KdispMatR(i) = dat(2)
        Next i

        ReDim RMmatrix(Norder)
        aa$ = sr.ReadLine
        For i = 1 To Norder
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            RMmatrix(i) = dat(1)
        Next i

        If KindVEqua > 0 Then
            Select Case KindDamp
                Case 0
                    aa$ = sr.ReadLine
                    dat = aa.Split(",")
                    CoeffM = dat(1)
                    aa$ = sr.ReadLine
                    dat = aa.Split(",")
                    CoeffK = dat(1)
                Case 1
                    ReDim Cmatrix(Norder)
                    aa$ = sr.ReadLine
                    For i = 1 To Norder
                        aa$ = sr.ReadLine
                        dat = aa.Split(",")
                        Cmatrix(i) = dat(1)
                    Next i
            End Select
        End If

        If Ntype = 1 Then
            Ndim = 2
        Else
            Ndim = 3
        End If

        aa$ = sr.ReadLine
        aa$ = sr.ReadLine
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        NPvib = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        NLvib = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        If KAnal = 0 Then
            NvibTime = dat(1)
            ReDim FLvibTime(NvibTime, NLvib)
        Else
            FreqLVib = dat(1)
            ReDim DataFreq(NLvib, 2)
        End If
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        KindLvib = dat(1)
        ReDim KPvib(NPvib), JLoadVib(NPvib, 3)

        aa$ = sr.ReadLine
        For i = 1 To NPvib
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            KPvib(i) = dat(1)
            For id = 1 To Ndim
                JLoadVib(i, id) = dat(id + 1)
            Next id
        Next i

        If KAnal = 0 Then
            aa$ = sr.ReadLine
            For i = 0 To NvibTime
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                For j = 1 To NLvib
                    FLvibTime(i, j) = dat(j)
                Next j
            Next i
        Else
            aa$ = sr.ReadLine
            For i = 1 To NLvib
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                DataFreq(i, 1) = dat(1)
                DataFreq(i, 2) = dat(2)
            Next i
        End If

        sr.Close()

    End Sub

    Sub DfileOutU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙへの書き出し
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾃﾞｰﾀﾌｧｲﾙ名
        Dim a1$, aa$, ad$
        Dim i, ib, id, j, n As Integer

        a1$ = ""
        Dim sw As New IO.StreamWriter(fxx$)

        aa$ = "プログラム名" + "," + "BarsVibRes"
        sw.WriteLine(aa$)
        aa$ = "［Bars2D構造ﾌｧｲﾙ］" + "," + Fbars$
        sw.WriteLine(aa$)
        sw.WriteLine(Title$)
        aa$ = "問題のタイプ" + "," + Str(Ntype)
        sw.WriteLine(aa$)
        aa$ = "節点数" + "," + Str(Npoint)
        sw.WriteLine(aa$)
        aa$ = "方程式種類(0:MK型、1:MCK型)" + "," + Str(KindVEqua)
        sw.WriteLine(aa$)
        If KindVEqua = 0 Then
            KindDamp = 0
            Ndamp = 0
        Else
            aa$ = "減衰設定区分(0:比例減衰、1:個別設定)" + "," + Str(KindDamp)
            sw.WriteLine(aa$)
            aa$ = "ダンパー数" + "," + Str(Ndamp)
            sw.WriteLine(aa$)
        End If
        aa$ = "解析の種類（0:一般応答、1:周波数応答）"
        aa$ = aa$ + "," + Str(KAnal)
        sw.WriteLine(aa$)
        aa$ = "境界拘束の解除（0:なし、1:有り）"
        aa$ = aa$ + "," + Str(Kboundfree)
        sw.WriteLine(aa$)
        aa$ = "行列の次数" + "," + Str(Norder)
        sw.WriteLine(aa$)
        aa$ = "材料データ数" + "," + Str(Nmat)
        sw.WriteLine(aa$)

        If Ndamp > 0 Then
            aa$ = "＜ダンパーデータ＞No.、節点番号1、節点番号2、外部点X、Y、減衰係数"
            sw.WriteLine(aa$)
            For i = 1 To Ndamp
                aa$ = Str$(i) + ",  " + Str$(KPdamp(i, 1)) + ",  " + Str$(KPdamp(i, 2))
                For j = 1 To 3
                    aa$ = aa$ + ",  " + Str$(DataDamp(i, j))
                Next j
                sw.WriteLine(aa$)
            Next i
        End If

        sw.WriteLine("＜材料の密度＞材料番号、密度")
        For i = 1 To Nmat
            aa$ = Str$(i) + ",  " + Str$(RouMat(i))
            sw.WriteLine(aa$)
        Next i

        aa$ = "＜行列の変数番号対応＞変数番号、節点番号、変位方向"
        sw.WriteLine(aa$)
        For i = 1 To Norder
            aa$ = Str$(i) + ",  " + Str$(NodeMatR(i))
            aa$ = aa$ + ",  " + Str$(KdispMatR(i))
            sw.WriteLine(aa$)
        Next i

        sw.WriteLine("＜Ｍ行列（質量マトリックス）＞行番号、対角要素")
        For i = 1 To Norder
            aa$ = Str$(i) + ",  "
            aa$ = aa$ + Str$(RMmatrix(i))
            sw.WriteLine(aa$)
        Next i

        If KindVEqua = 1 Then
            Select Case KindDamp
                Case 0
                    aa$ = "質量比例の減衰係数" + "," + Str(CoeffM)
                    sw.WriteLine(aa$)
                    aa$ = "剛性比例の減衰係数" + "," + Str(CoeffK)
                    sw.WriteLine(aa$)
                Case 1
                    sw.WriteLine("＜Ｃ行列（減衰マトリックス）＞行番号、各要素")
                    For i = 1 To Norder
                        aa$ = Str$(i) + ",  "
                        aa$ = aa$ + Str$(Cmatrix(i))
                        sw.WriteLine(aa$)
                    Next i
            End Select
        End If

        ad$ = "-------------------------------------------------------"
        sw.WriteLine(ad$)
        sw.WriteLine("＜振動外力データ＞")
        aa$ = "振動外力の節点数" + "," + Str(NPvib)
        sw.WriteLine(aa$)
        aa$ = "振動外力の荷重個数" + "," + Str(NLvib)
        sw.WriteLine(aa$)
        If KAnal = 0 Then
            aa$ = "振動外力の時間メッシュ数" + "," + Str(NvibTime)
            sw.WriteLine(aa$)
        Else
            aa$ = "振動外力の周波数" + "," + Str(FreqLVib)
            sw.WriteLine(aa$)
        End If
        aa$ = "振動外力の種類（0:力、1:加速度）" + "," + Str(KindLvib)
        sw.WriteLine(aa$)
        aa$ = "No.、節点番号、X方向有無、Y方向有無"
        If Ntype > 1 Then
            aa$ = aa$ + "、θ方向有無"
        End If
        If Ntype = 1 Then
            Ndim = 2
        Else
            Ndim = 3
        End If
        sw.WriteLine(aa$)
        For i = 1 To NPvib
            aa$ = Str$(i) + ",  " + Str$(KPvib(i))
            For id = 1 To Ndim
                aa$ = aa$ + ",   " + Str$(JLoadVib(i, id))
            Next id
            sw.WriteLine(aa$)
        Next i

        If KAnal = 0 Then
            aa$ = "時間No."
            For i = 1 To NPvib
                ib = KPvib(i)
                For id = 1 To Ndim
                    j = JLoadVib(i, id)
                    If j > 0 Then
                        Select Case id
                            Case 1
                                a1$ = "u"
                            Case 2
                                a1$ = "v"
                            Case 3
                                a1$ = "θ"
                        End Select
                        a1$ = a1$ + LTrim$(Str$(ib))
                        aa$ = aa$ + "、" + a1$
                    End If
                Next id
            Next i
            sw.WriteLine(aa$)
            For i = 0 To NvibTime
                aa$ = Str$(i)
                For j = 1 To NLvib
                    aa$ = aa$ + ",  " + Str$(FLvibTime(i, j))
                Next j
                sw.WriteLine(aa$)
            Next i
        Else
            aa$ = "変位方向、振幅、位相差"
            sw.WriteLine(aa$)
            n = 0
            For i = 1 To NPvib
                ib = KPvib(i)
                For id = 1 To Ndim
                    j = JLoadVib(i, id)
                    If j > 0 Then
                        n = n + 1
                        Select Case id
                            Case 1
                                a1$ = "u"
                            Case 2
                                a1$ = "v"
                            Case 3
                                a1$ = "θ"
                        End Select
                        aa$ = a1$ + LTrim$(Str$(ib))
                        aa$ = aa$ + ",  " + Str(DataFreq(n, 1))
                        aa$ = aa$ + ",  " + Str(DataFreq(n, 2))
                        sw.WriteLine(aa$)
                    End If
                Next id
            Next i
        End If

        sw.Close()

        aa$ = "データをファイルへ保存しました。"
        MsgBox(aa$, 0, "ファイル保存完了")

    End Sub

    Function DispMax(ByVal k1 As Integer, ByRef k2 As Integer, _
    ByRef tdb(,) As Single) As Single
        '変位の最大値
        'k1,k2･･･要素の開始、終了番号
        'dmax･･･X座標最小値
        'tdb(,)･･･節点の各座標方向変位
        Dim i, ie, j, k As Integer
        Dim b1, dmax As Single
        dmax = 0
        For ie = k1 To k2
            If KdrawElem(ie) > 0 Then
                For j = 1 To 2
                    i = NNelem(ie, j)
                    For k = 1 To 2
                        b1 = Math.Abs(tdb(i, k))
                        If b1 > dmax Then
                            dmax = b1
                        End If
                    Next k
                Next j
            End If
        Next ie
        Return dmax

    End Function

    Sub DispRateAnim(ByRef ratio As Single, ByVal rlen2 As Single)
        '変位作画倍率の設定
        'ratio･･･変位作画の倍率
        'rlen2･･･最大変位
        Dim b1, rlen, xmax, xmin, ymax, ymin As Single

        Call AxisCheckS(KE1, KE2, xmin, xmax, ymin, ymax, X, Y)
        '座標の最小・最大値のﾁｪｯｸ
        rlen = xmax - xmin
        b1 = ymax - ymin
        If b1 > rlen Then
            rlen = b1
        End If

        ratio = rlen2 / rlen
        Call AdjustRatio(ratio)     '変位比率の調整

    End Sub

    Sub DispRateSet(ByRef ratio As Single, ByVal tfdb(,) As Single)
        '変位作画倍率の設定
        'ratio･･･変位作画の倍率
        'tfdb(,)･･･節点の各座標変位
        Dim b1, rlen, rlen2, xmax, xmin, ymax, ymin As Single

        Call AxisCheckS(KE1, KE2, xmin, xmax, ymin, ymax, X, Y)
        '座標の最小・最大値のﾁｪｯｸ
        rlen = xmax - xmin
        b1 = ymax - ymin
        If b1 > rlen Then
            rlen = b1
        End If
        rlen2 = DispMax(KE1, KE2, tfdb)
        ratio = rlen2 / rlen
        Call AdjustRatio(ratio)     '変位比率の調整

    End Sub

    Sub DrawFocusRect(ByRef gr As Graphics)
        'ﾌｫｰｶｽ矩形の描画
        Dim rect As Rectangle
        Dim p1, p2 As Point

        If Xmouse(1) <= Xmouse(2) Then
            p1.X = Xmouse(1)
            p2.X = Xmouse(2)
        Else
            p1.X = Xmouse(2)
            p2.X = Xmouse(1)
        End If
        If Ymouse(1) <= Ymouse(2) Then
            p1.Y = Ymouse(1)
            p2.Y = Ymouse(2)
        Else
            p1.Y = Ymouse(2)
            p2.Y = Ymouse(1)
        End If
        rect.X = p1.X
        rect.Y = p1.Y
        rect.Width = p2.X - p1.X
        rect.Height = p2.Y - p1.Y

        gr.DrawRectangle(Pens.DarkGray, rect)   '矩形の描画

    End Sub

    Sub DrawScale(ByRef icheck As Integer, ByVal dpixb As Single, _
        ByVal dpiyb As Single, ByVal xlen As Single, ByVal ylen As Single, _
        ByVal xmin As Single, ByVal xmax As Single, _
        ByVal ymin As Single, ByVal ymax As Single)
        '作画倍率の計算
        'icheck･･･作画直角回転要否（0:回転なし、1:直角回転要）
        'dpixb･･･X軸方向のdpi値
        'dpiyb･･･Y軸方向のdpi値
        'xlen･･･作画領域のX方向長さ
        'ylen･･･作画領域のY方向長さ
        'xmin･･･X座標最小値
        'xmax･･･X座標最大値
        'ymin･･･Y座標最小値
        'ymax･･･Y座標最大値
        Dim b1, b2, cx, cy As Single

        Cfix = dpiyb / dpixb

        b1 = xmax - xmin : b2 = ymax - ymin
        Select Case icheck
            Case 0
                If Cfix < 1 Then
                    If b1 <> 0 Then
                        cx = xlen / b1
                    End If
                    If b2 <> 0 Then
                        cy = ylen / b2 / Cfix
                    End If
                Else
                    If b1 <> 0 Then
                        cx = Cfix * xlen / b1
                    End If
                    If b2 <> 0 Then
                        cy = ylen / b2
                    End If
                End If
                If b1 = 0 Then
                    XYscale = cy
                ElseIf b2 = 0 Then
                    XYscale = cx
                ElseIf cy < cx Then
                    XYscale = cy
                Else
                    XYscale = cx
                End If
            Case 1
                If Cfix < 1 Then
                    If b2 <> 0 Then
                        cx = xlen / b2
                    End If
                    If b1 <> 0 Then
                        cy = ylen / b1 / Cfix
                    End If
                Else
                    If b2 <> 0 Then
                        cx = Cfix * xlen / b2
                    End If
                    If b1 <> 0 Then
                        cy = ylen / b1
                    End If
                End If
                If b2 = 0 Then
                    XYscale = cy
                ElseIf b1 = 0 Then
                    XYscale = cx
                ElseIf cy < cx Then
                    XYscale = cy
                Else
                    XYscale = cx
                End If
        End Select

    End Sub

    Sub Elem2DPrep()
        '構造図作画準備
        Dim ie As Integer
        Dim pa, qa, ratio As Single
        ReDim KdrawElem(Nelem)

        KE1 = 1
        KE2 = Nelem
        KnumSize = 8
        For ie = KE1 To KE2
            KdrawElem(ie) = 1
        Next ie

        ratio = 1.2
        Kaxis = 0
        Call AxisCheck(Kaxis, 1, Nelem, ratio, XaxisMin, pa, YaxisMin, qa, X, Y)
        'X、Y軸の最小・最大値と作画直角回転要否のﾁｪｯｸ

    End Sub

    Sub ElemSearch(ByRef k1 As Integer, ByRef k2 As Integer, _
    ByRef xsb() As Single, ByRef ysb() As Single)
        '拡大作画する要素の探索
        '両節点が指定領域にある要素を採用、作画要素なしの場合は元のﾃﾞｰﾀを保存
        'k1,k2･･･要素の開始、終了番号
        'xsb(),ysb()･･･節点のｽｸﾘｰﾝ座標
        Dim ib, ic, ie, j, kmax, kmin As Integer
        Dim b1, b2 As Single
        Dim kbuf(Nelem) As Integer
        ic = 0
        For ie = 1 To Nelem
            kbuf(ie) = KdrawElem(ie)
            If KdrawElem(ie) > 0 Then
                For j = 1 To 2
                    ib = NNelem(ie, j)
                    b1 = xsb(ib) - Xmouse(1)
                    b2 = xsb(ib) - Xmouse(2)
                    If b1 >= 0 And b2 <= 0 Then
                        If Kaxis = 0 Then
                            b1 = ysb(ib) - Ymouse(2)
                            b2 = ysb(ib) - Ymouse(1)
                        Else
                            b1 = ysb(ib) - Ymouse(1)
                            b2 = ysb(ib) - Ymouse(2)
                        End If
                        If b1 >= 0 And b2 <= 0 Then
                            If j = 2 Then
                                KdrawElem(ie) = 1
                                If ic = 0 Then
                                    ic = 1
                                    kmin = ie
                                    kmax = ie
                                ElseIf ie < kmin Then
                                    kmin = ie
                                ElseIf ie > kmax Then
                                    kmax = ie
                                End If
                            End If
                        Else
                            KdrawElem(ie) = 0
                            Exit For
                        End If
                    Else
                        KdrawElem(ie) = 0
                        Exit For
                    End If
                Next j
            End If
        Next ie
        k1 = kmin
        k2 = kmax
        If k1 = 0 Then
            For ie = 1 To Nelem
                KdrawElem(ie) = kbuf(ie)
            Next ie
        End If

    End Sub

    Sub FileName(ByVal fxx$, ByRef fxb$)
        'ﾌｧｲﾙ名fxx$の拡張子なしの部分fxb$を取り出す
        Dim i As Integer
        i = InStr(fxx$, ".")
        If i > 0 Then
            fxb$ = Left$(fxx$, i - 1)
        Else
            fxb$ = fxx$
        End If
    End Sub

    Sub MatErrorCheck(ByRef kh As Integer)  '物性ｴﾗｰﾁｪｯｸ
        'kh･･･ｴﾗｰ有無（0：なし、-1：有り）
        Dim i, j As Integer

        kh = 0
        For i = 1 To Nmat
            For j = 1 To Mprop
                If j <> 2 Then
                    If DataMat(i, j) <= 0 Then
                        kh = -1
                        Exit Sub
                    End If
                End If
            Next j
        Next i

    End Sub

    Sub MouseCalc(ByVal xa As Single, ByRef xb As Single, ByVal ya As Single, ByRef yb As Single)
        'ﾏｳｽ点のﾓﾃﾞﾙ座標への変換
        'xa,ya･･･ﾏｳｽ点座標
        'xb,yb･･･ﾓﾃﾞﾙ座標
        If Cfix < 1 Then
            If Kaxis = 0 Then
                xb = (xa - Xlower) / XYscale + XaxisMin
                yb = (Yupper - ya) / XYscale / Cfix + YaxisMin
            Else
                xb = (ya - Ylower) / XYscale / Cfix + XaxisMin
                yb = (xa - Xlower) / XYscale + YaxisMin
            End If
        Else
            If Kaxis = 0 Then
                xb = Cfix * (xa - Xlower) / XYscale + XaxisMin
                yb = (Yupper - ya) / XYscale + YaxisMin
            Else
                xb = (ya - Ylower) / XYscale + XaxisMin
                yb = Cfix * (xa - Xlower) / XYscale + YaxisMin
            End If
        End If

    End Sub

    Sub MouseCalc2()
        'ﾏｳｽ点のﾓﾃﾞﾙ座標への変換
        Dim j As Integer
        Dim xa, xb, ya, yb As Single
        For j = 1 To 2
            xa = Xmouse(j)
            ya = Ymouse(j)
            If Cfix < 1 Then
                If Kaxis = 0 Then
                    xb = (xa - Xlower) / XYscale + XaxisMin
                    yb = (Yupper - ya) / XYscale / Cfix + YaxisMin
                Else
                    xb = (ya - Ylower) / XYscale / Cfix + XaxisMin
                    yb = (xa - Xlower) / XYscale + YaxisMin
                End If
            Else
                If Kaxis = 0 Then
                    xb = Cfix * (xa - Xlower) / XYscale + XaxisMin
                    yb = (Yupper - ya) / XYscale + YaxisMin
                Else
                    xb = (ya - Ylower) / XYscale + XaxisMin
                    yb = Cfix * (xa - Xlower) / XYscale + YaxisMin
                End If
            End If
            Xmouse(j) = xb
            Ymouse(j) = yb
        Next j

    End Sub

    Sub MousePointSearch(ByVal k1 As Integer, ByVal k2 As Integer, _
    ByRef kp As Integer, ByVal xb As Single, ByVal yb As Single, _
    ByRef xmb() As Single, ByRef ymb() As Single)
        'ﾏｳｽ点の節点の探索
        'k1,k2･･･要素の開始、終了番号
        'kp･･･ﾏｳｽ点の節点番号
        'xb,yb･･･ﾏｳｽ点のﾓﾃﾞﾙ座標位置
        'xmb(),ymb()･･･節点のｽｸﾘｰﾝ座標
        Dim ib, ie, j As Integer
        Dim b1, b2, b3, rlen2 As Single
        Dim kbuf(Npoint) As Integer

        kp = 0
        For ie = k1 To k2
            If KdrawElem(ie) > 0 Then
                For j = 1 To 2
                    ib = NNelem(ie, j)
                    If kbuf(ib) = 0 Then
                        kbuf(ib) = 1
                        b1 = xmb(ib) - xb
                        b2 = ymb(ib) - yb
                        b3 = b1 * b1 + b2 * b2
                        If kp = 0 Or b3 < rlen2 Then
                            kp = ib
                            rlen2 = b3
                        End If
                    End If
                Next j
            End If
        Next ie

    End Sub

    Sub NvarPDSet()
        '元ﾃﾞｰﾀ節点の変数の数を設定
        Dim i, ib, ii, ip, j, k, nb As Integer

        For i = 1 To Npoint
            NvarPD(i) = 2
        Next i
        For i = 1 To Nelem
            If KindElem(i) > 1 Then
                For j = 1 To 2
                    k = NNelem(i, j)
                    NvarPD(k) = 3
                Next j
            End If
        Next i

        '行列の変数番号の対応設定
        ii = 0
        For ip = 1 To Npoint
            nb = NvarPD(ip)
            ib = 0
            LrD(ip) = ii + 1
            For j = 1 To nb
                ii = ii + 1
                ib = ib + 1
                Nodemb(ii) = ip
                Kdispmb(ii) = ib
            Next j
        Next ip

    End Sub

    Sub OptFileIn()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ読み込み
        Dim ftmp$

        ftmp$ = DirOpen$ + "\BarsVRMenu.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            KdataBackup = Val(sr.ReadLine)
            Kscreen = Val(sr.ReadLine)
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub OptFileOut()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ書き出し
        Dim ftmp$

        ftmp$ = DirOpen$ + "\BarsVRMenu.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(KdataBackup)
        sw.WriteLine(Kscreen)
        sw.Close()

    End Sub

    Sub ResFileScan(ByVal ii As Integer)
        '結果ﾌｧｲﾙの読み飛ばし
        'ii･･･ﾌｧｲﾙ番号
        Dim aa$
        Dim i As Integer

        aa$ = ""
        Do
            Input(ii, aa$)
            If aa$ = "＜変位データ＞" Then
                Exit Do
            End If
        Loop
        Input(ii, aa$)
        For i = 1 To Npoint
            aa$ = LineInput(ii)
        Next i
        Input(ii, aa$) : Input(ii, aa$) : Input(ii, aa$)
        For i = 1 To 2 * Nelem
            aa$ = LineInput(ii)
        Next i
        Input(ii, aa$) : Input(ii, aa$) : Input(ii, aa$)
        For i = 1 To Npoint
            aa$ = LineInput(ii)
        Next i

    End Sub

    Sub ResFileScanU(ByVal sr As IO.StreamReader)
        '結果ﾌｧｲﾙの読み飛ばし
        'UTF-8･･･BOMなし
        Dim aa$
        Dim i As Integer

        aa$ = ""
        Do
            aa$ = sr.ReadLine
            If aa$ = "＜変位データ＞" Then
                Exit Do
            End If
        Loop
        aa$ = sr.ReadLine
        For i = 1 To Npoint
            aa$ = sr.ReadLine
        Next i
        aa$ = sr.ReadLine
        aa$ = sr.ReadLine
        aa$ = sr.ReadLine
        For i = 1 To 2 * Nelem
            aa$ = sr.ReadLine
        Next i
        aa$ = sr.ReadLine
        aa$ = sr.ReadLine
        aa$ = sr.ReadLine
        For i = 1 To Npoint
            aa$ = sr.ReadLine
        Next i

    End Sub

    Sub RoundPrep(ByRef kind As Integer, ByRef nb As Integer, ByVal zb As Single)
        '丸め準備
        'kind･･･丸め区分（0:1以上、1:1未満）
        'nb･･･丸め位置の桁数
        'zb･･･丸め基準値
        Dim i, ib As Integer
        Dim b2 As Single

        b2 = zb
        nb = 0
        i = Int(b2)
        If i > 0 Then
            kind = 0
            Do
                ib = CInt(b2)
                If ib < 10 Then
                    Exit Do
                Else
                    nb = nb + 1
                    b2 = b2 * 0.1
                End If
            Loop
        Else
            kind = 1
            Do
                ib = CInt(b2)
                If ib > 0 Then
                    Exit Do
                Else
                    nb = nb + 1
                    b2 = b2 * 10
                End If
            Loop
        End If

    End Sub

    Sub RoundTreat(ByVal kind As Integer, ByVal nb As Integer, ByRef zb As Single)
        '丸め処理
        'kind･･･丸め区分（0:1以上、1:1未満）
        'nb･･･丸め位置の桁数
        'zb･･･対象変数
        Dim ib As Integer
        Dim b1 As Single

        If kind = 0 Then
            b1 = zb * 10 ^ (-nb)
            ib = CInt(b1)
            zb = ib * 10 ^ nb
        Else
            b1 = zb * 10 ^ nb
            ib = CInt(b1)
            zb = ib * 10 ^ (-nb)
        End If

    End Sub

    Sub TimCal(ByVal ktim As Integer, ByRef timn$)
        'ﾀｲﾏｰ計算
        'ktim･･･時間継続指定（0:時間ｸﾘｱする、1:時間継続する）
        'timn$･･･時分秒に換算した経過時間
        Dim rtime As Date = Now
        Dim rhour, rmin, sec As Single
        If ktim > 0 Then
            sec = DateDiff(DateInterval.Second, Timst, rtime)
            rhour = Int(sec / 3600) : sec = sec - rhour * 3600
            rmin = Int(sec / 60) : sec = Int(sec - rmin * 60)
            timn$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(sec) + "s"
        Else
            Timst = rtime
        End If
    End Sub

    Sub TmpFileIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        Dim ftmp$

        ftmp$ = DirOpen$ + "\BarsVibRes.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            Fbars$ = sr.ReadLine
            Fm$ = sr.ReadLine
            Fy$ = sr.ReadLine
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub TmpFileOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        Dim ftmp$

        ftmp$ = DirOpen$ + "\BarsVibRes.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(Fbars$)
        sw.WriteLine(Fm$)
        sw.WriteLine(Fy$)
        sw.Close()

    End Sub

    Sub UFileAddA()
        'UFileAの追加処理
        Dim i, ic, j As Integer
        ic = 0
        For i = 2 To 6
            If UFileA(i) = UFileA(0) Then
                For j = i - 1 To 0 Step -1
                    UFileA(j + 1) = UFileA(j)
                Next j
                ic = 1
                Exit For
            End If
        Next i
        If ic = 0 Then
            For i = 5 To 0 Step -1
                UFileA(i + 1) = UFileA(i)
            Next i
        End If
        UseFileAOut()       'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し

    End Sub

    Sub UFileAddB()
        'UFileBの追加処理
        Dim i, ic, j As Integer
        ic = 0
        For i = 2 To 6
            If UFileB(i) = UFileB(0) Then
                For j = i - 1 To 0 Step -1
                    UFileB(j + 1) = UFileB(j)
                Next j
                ic = 1
                Exit For
            End If
        Next i
        If ic = 0 Then
            For i = 5 To 0 Step -1
                UFileB(i + 1) = UFileB(i)
            Next i
        End If
        UseFileBOut()       'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し

    End Sub

    Sub UseFileAIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\BarsVRUFileA.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            i = 0
            Do Until sr.Peek = -1 'ﾌｧｲﾙ末尾まで
                i = i + 1
                UFileA(i) = sr.ReadLine
            Loop
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub UseFileAOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\BarsVRUFileA.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        For i = 1 To 6
            If UFileA(i) <> "" Then
                sw.WriteLine(UFileA(i))
            Else
                Exit For
            End If
        Next i
        sw.Close()

    End Sub

    Sub UseFileBIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\BarsVRUFileB.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            i = 0
            Do Until sr.Peek = -1 'ﾌｧｲﾙ末尾まで
                i = i + 1
                UFileB(i) = sr.ReadLine
            Loop
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub UseFileBOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\BarsVRUFileB.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        For i = 1 To 6
            If UFileB(i) <> "" Then
                sw.WriteLine(UFileB(i))
            Else
                Exit For
            End If
        Next i
        sw.Close()

    End Sub

    Sub XYCalc2(ByRef icheck As Integer, ByRef xb As Single, _
        ByRef yb As Single)
        'X,Yの作画座標計算
        'icheck･･･作画時のXY入れ替えの有無（0:なし、1:有り）
        'xb･･･X座標値
        'yb･･･Y座標値
        Dim b1, b2 As Single
        b1 = xb - XaxisMin
        b2 = yb - YaxisMin
        If Cfix < 1 Then
            If icheck = 0 Then
                xb = b1 * XYscale + Xlower
                yb = Yupper - b2 * XYscale * Cfix
            Else
                xb = b2 * XYscale + Xlower
                yb = b1 * XYscale * Cfix + Ylower
            End If
        Else
            If icheck = 0 Then
                xb = b1 * XYscale / Cfix + Xlower
                yb = Yupper - b2 * XYscale
            Else
                xb = b2 * XYscale / Cfix + Xlower
                yb = b1 * XYscale + Ylower
            End If
        End If
    End Sub

End Module
